//+------------------------------------------------------------------+
//|                                                Ambush_IV_GBP.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|     Based on David Willis' TheOnlyPivot_multi.mq4 expert advisor |
//| Alpari UK, standard-account settings:                            |
//|  H1  5,11,15 = 16,824;  BackTest: 02-Jan-2008 .. 14-Jun-2008     |
//|  M30 4,10,14 = 15,027;  BackTest: 02-Jan-2008 .. 14-Jun-2008     |
//|  M15 4,10,14 = 11,223;  BackTest: 02-Jan-2008 .. 14-Jun-2008     |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"                                 //|
//+------------------------------------------------------------------+
extern double Lots    =0.6;  
extern int    JP_open =  5; // 0=15,439;  1=14,994;  2=15,311;  3=15,631;  4=15,125;  5=16,824; 6=16,490; 7=16,339; 8=14,577
extern int    EU_open = 11; // 7= 2,823;  8= 3,653;  9= 8,781; 10=12,777; 11=16,824; 12=14,598
extern int    US_open = 15; //11=11,335; 12=15,422; 13=13,054; 14=14,563; 15=16,824; 16=13,522
extern int    endtradingtime = 24;
extern int    slippage       = 5;
extern int    MagicNumber    = 12358;
extern int    SpikeStopLoss  = 50;

//+---------
int init()
  {
   return(0);
  }
//+---------
int deinit()
  {
   return(0);
  }
//+---------
int start()
{
 int numbertrades=3;
 int tradedirection=tradedirection();
 double sl,tp1,tp2,tp3;
 double LongPT3    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,0); // Fibonacci Extension +1.618
 double LongPT2    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,1,0); // Fibonacci Extension +1.272
 double LongPT1    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,2,0); // Previous Session High
 double AmbushHigh = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,3,0); // Fibonacci 0.618
 double StopLong   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,4,0); // Fibonacci 0.382
 double StopShort  = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,3,0); // Fibonacci 0.618
 double AmbushLow  = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,4,0); // Fibonacci 0.382
 double ShortPT1   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,5,0); // Previous Session Low
 double ShortPT2   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,6,0); // Fibonacci Extension -1.272
 double ShortPT3   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,7,0); // Fibonacci Extension -1.618
 
 double SpikeStopLong  = AmbushHigh - (SpikeStopLoss*Point);
 double SpikeStopShort = AmbushLow  + (SpikeStopLoss*Point);
 
 int Start_time=startime(); 

// Take care of open trades
 if(opentrades()>0)
 {
  if(tradedirection==1) {modifystoploss(LongPT1, LongPT2, AmbushHigh,LongPT1);}
  if(tradedirection==0) {modifystoploss(ShortPT1,ShortPT2,AmbushLow,ShortPT1);}
  // if close on opposite side of range close all trades
  if(tradedirection==1 && (Close[1]<StopLong  || Close[0]<SpikeStopLong))  {closealltrades();}
  if(tradedirection==0 && (Close[1]>StopShort || Close[0]>SpikeStopShort)) {closealltrades();} 
 }
// New close above or below Ambush Zone 
 if (tradingtime(Start_time)>0 && opentrades()<1)
 {
// LONG entry during the day
   if(Low[1]<AmbushHigh && Close[1]>AmbushHigh && Close[0]>AmbushHigh && Close[0]<LongPT1 && Open[1]<Close[1])
   {
   sl=0; // use the close of other side to exit
   tp1=LongPT1;
   tp2=LongPT2;
   tp3=LongPT3; 
    
   if (opentrades()==0)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
 }
// SHORT entry during the day
   if(High[1]>AmbushLow && Close[1]<AmbushLow && Close[0]<AmbushLow && Close[0]>ShortPT1 && Open[1]>Close[1])
   {
   sl=0;
   tp1=ShortPT1;
   tp2=ShortPT2;
   tp3=ShortPT3;
      
   if(opentrades()==0)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
  }
 }
 return(0); 
}
//+------------------------------------------------------------------+

int startime()
{
 int cnt, startime;
 
 for(cnt=0;cnt<24;cnt++)
 {
  if(iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,cnt+1)!=iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,cnt))
  {
   startime=Hour()-cnt;
   if (startime<0){startime=startime+24;}
   return(startime);
  }
 }
}

void modifystoploss(double sla1,double sla2, double sl1,double sl2)
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  

  //for long trades
  if(tradedirection()==1)
  {       
    if(Close[1]>= sla1) {newsl=sl1;}
    if(Close[1]>= sla2) {newsl=sl2;}
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(Close[1]<= sla1) {newsl=sl1;}
    if(Close[1]<= sla2) {newsl=sl2;}
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
}

int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}

void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<10;cnt++)
  {
    closetrades();
    if(opentrades()==0){cnt=10;}
  }
}  

void closetrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}

int tradedirection()
{

  int cnt;
  int direction;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
 
int tradingtime(int Start_time)
{
  int trading=0;
  
  if(Start_time<endtradingtime && Hour()<endtradingtime && Hour()>Start_time) {trading=1;}
  if(Start_time>endtradingtime)
  {
    if(Hour()>Start_time)    {trading=1;}
    if(Hour()<endtradingtime){trading=1;}
  }
  return(trading);
}
//+---------------------------------------------------------------------------+
//|                              THE END                                      |
//+---------------------------------------------------------------------------+